include \masm32\MasmBasic\MasmBasic.inc	; http://www.masm32.com/board/index.php?topic=12460

; create the alltest.inc from the command line with copy *.inc alltest.inc

arrfile2 PROTO :DWORD
    get_line_count PROTO :DWORD,:DWORD
    
.data
    m_inFile BYTE "\Masm32\include\Windows.inc",0
    m_inArray      DWORD   0       
.code

start:
	ShowString2 = 1
	NumLoops=73
    print "Testing arrfile$ on Windows.inc", 13, 10
	mov ebx, NumLoops
	push Timer
	.Repeat
		invoke arrfile2, addr m_inFile
		mov m_inArray, EAX
		if ShowString2
			.if !ebx
				print [eax+12], 13, 10
			.endif
		endif
		invoke arrfree, m_inArray
		dec ebx
	.Until Sign?
	void Timer
	pop edx
	Print Str$("\n%i milliseconds for arrfile$\n\n", eax-edx)

    print "Testing Recall on Windows.inc", 13, 10
	mov ebx, NumLoops
	push Timer
	.Repeat
		Recall "\Masm32\include\Windows.inc", L$()
		if ShowString2
			.if !ebx
				PrintLine L$(2)
			.endif
		endif
		Erase L$()
		dec ebx
	.Until Sign?
	void Timer
	pop edx
	Print Str$("\n%i milliseconds for Recall\n\n", eax-edx)

	NumLoops=7
    print "Testing arrfile$ on alltest.inc", 13, 10
	mov ebx, NumLoops
	push Timer
	.Repeat
		invoke arrfile2, chr$("\masm32\include\alltest.inc")
		mov m_inArray, EAX
		if ShowString2
			.if !ebx
				print [eax+12], 13, 10
			.endif
		endif
		invoke arrfree, m_inArray
		dec ebx
	.Until Sign?
	void Timer
	pop edx
	Print Str$("\n%i milliseconds for arrfile$\n\n", eax-edx)

    print "Testing Recall on alltest.inc", 13, 10
	mov ebx, NumLoops
	push Timer
	.Repeat
		Recall "\masm32\include\alltest.inc", L$()
		if ShowString2
			.if !ebx
				PrintLine L$(2)
			.endif
		endif
		Erase L$()
		dec ebx
	.Until Sign?
	void Timer
	pop edx
	Print Str$("\n%i milliseconds for Recall\n", eax-edx)


	Inkey CrLf$, "That was cute, thanks."
    exit


; 

arrfile2 proc file_name:DWORD

    LOCAL arr   :DWORD
    LOCAL hMem  :DWORD
    LOCAL flen  :DWORD
    LOCAL lcnt  :DWORD
    LOCAL pbuf  :DWORD
    LOCAL spos  :DWORD
    LOCAL lvoid  :DWORD

    push ebx
    mov hMem, InputFile(file_name)
    mov flen, ecx
    add flen, 2 ; <<<<<<<<<<<<<<<<<<<<<<<<<<<< added this
    mov lcnt, rv(get_line_count,hMem,flen)
    mov arr, arralloc$(lcnt)
    mov pbuf, alloc(flen)

    mov spos, 0
    mov ebx, 1
  @@:
    mov spos, rv(readline,hMem,pbuf,spos)
    mov lvoid, arrset$(arr,ebx,pbuf)
    add ebx, 1
    cmp ebx, lcnt
    jle @B

    free pbuf
    free hMem

    mov eax, arr
    pop ebx

    ret

arrfile2 endp


; 

end start

OPT_Res	0	   ; RichMasm assumes this code needs no resources - delete if rsrc.rc is needed
OPT_Wait	0
OPT_Tmp2Asm	1
